import java.util.Collections;
import java.util.LinkedList;

/**
 * Compute the convex hull of S using the incremental algorithm. 
 */ 
Polygon convexHullIncremental(ArrayList<Point2d> S) {
  
  // Sort S by x-coordinate using the Point2dXComparator: 
  Collections.sort(S, new Point2dXComparator());
  
  // Initialize the convex hull of the first three points
  // And make sure they the first three points are oriented counter clockwise:
  Polygon hull = new Polygon();
  if (isLeftHandTurn(S.get(0), S.get(1), S.get(2))) {
    hull.add(S.get(0));
    hull.add(S.get(1));
    hull.add(S.get(2));
  } else {
    hull.add(S.get(0));
    hull.add(S.get(2));
    hull.add(S.get(1));
  }
  
  // Now loop over the remaining points in S starting from k=3
  // and add each one to the convex hull to compute the hull
  // via the incremental algorithm. 
  
  // TODO
  
  return hull;
}

/** 
 * Compute the convex hull of S using the gift-wrapping algorithm.
 */ 
Polygon convexHullGiftWrapping(ArrayList<Point2d> S) {
  
  ArrayList<Point2d> polyPoints = new ArrayList<Point2d>();
  
  // Step 1: Find left-most point in S first. 
  Point2d p = S.get(0);
  for (int i = 1; i < S.size(); i++) {
    if (S.get(i).x < p.x) p = S.get(i);
  }
  polyPoints.add(p);
  
  // Step 2, until you get back around to the starting point p, 
  // find the right most turn from the last polygon vertex
  
  // TODO
  
  // Create a polygon object from the list of points:
  Polygon retPoly = new Polygon();
  for (int i = 0; i < polyPoints.size()-1; i++) {
    retPoly.add(polyPoints.get(i));
  }
  
  return retPoly;
}

Polygon convexHullGrahamScan(ArrayList<Point2d> S) {
  // Challenge problem. 
  // Compute the convex hull via Graham Scan
  return null;
}