class Polygon {

  Vertex firstVertex = null;
  int size = 0;
  
  public Vertex add(Point2d coord) {
    Vertex newVertex = new Vertex(coord);
    newVertex.name = size;
    if (firstVertex == null) {
      firstVertex = newVertex;
      firstVertex.next = firstVertex;
      firstVertex.prev = firstVertex;
    } else {
      firstVertex.prev.next = newVertex;
      newVertex.prev = firstVertex.prev;
      firstVertex.prev = newVertex;
      newVertex.next = firstVertex;
    }
    size++;
    return newVertex;
  }
  
  public void remove(Vertex v) {
    if (size <= 3) return;
    if (v == firstVertex) firstVertex = v.next;
    v.prev.next = v.next;
    v.next.prev = v.prev;
    size--;
  }
  
  public int size() { return this.size; }
}

class Diagonal {
  Vertex A, B; 
  public Diagonal(Vertex A, Vertex B) {
    this.A = A; 
    this.B = B; 
  }
}

class Vertex {
  Vertex next, prev; 
  Point2d coord; 
  int name;
  
  public Vertex(Point2d coord) {
    this.coord = coord;
  }
  
  public String toString() {
    return coord.toString();
  }
}